# WebtoonScraper와 저작권법

**이 문서 전체는 법적 조언이 아닙니다. 모든 행동에 대한 책임은 사용자 본인에게 있습니다.**

이 소프트웨어는 Apache 2.0 라이선스 하에 공유됩니다.

개발자는 소프트웨어를 '있는 그대로(AS-IS)' 제공하며, 사용자가 소프트웨어를 사용함에 따른 모든 결과에 대한 책임은 사용자에게 있습니다.

## 사적이용을 위한 복제

> 저작권법 제30조(사적이용을 위한 복제)
>
> 공표된 저작물을 영리를 목적으로 하지 아니하고 개인적으로 이용하거나 가정 및 이에 준하는 한정된 범위 안에서 이용하는 경우에는 그 이용자는 이를 복제할 수 있다. 다만, 공중의 사용에 제공하기 위하여 설치된 복사기기, 스캐너, 사진기 등 문화체육관광부령으로 정하는 복제기기에 의한 복제는 그러하지 아니하다.  <개정 2020. 2. 4.>

저작권법에는 사적 복제를 허용하는 조항이 있으며, 이 경우에는 저작권법에 합치되도록 이 패키지를 사용할 수 있습니다.

### 사적이용인 경우와 아닌 경우

* 혼자 보기 위해 웹툰을 다운로드해서 자신의 휴대폰으로 보는 경우: **사적이용에 해당할 확률 높음**

    *개인적으로 이용하거나 가정 및 이에 준하는 한정된 범위 안에서 이용하는 경우에는 그 이용자는 이를 복제할 수 있*습니다.

* 다운로드한 웹툰의 파일이나 스크린샷을 다른 사람에게 공유하거나 배포 또는 판매하는 경우: **사적이용 아님**

    개인적인 사용이 아니기 때문에 사적이용을 위한 복제에 해당하지 않습니다. 다만 공정 이용(후술)에 해당할 수는 있습니다.

* 웹툰을 다운로드해서 한정된 주변인이나 가족들에게 보여주거나 배포하는 경우: **확실하지 않음**

    *가정 및 이에 준하는 한정된 범위 안에서 이용하는 경우*에 포함되는 것으로도 볼 수 있고, 아닐 수도 있습니다. 하지만 괜한 법적 문제를 피하려면 타인에게 공유하는 것은 삼가해 주세요.

    이 패키지를 추천하거나 사용법을 공유하는 것은 저작권법 위반이 아닙니다. 타인에게는 직접 다운로드 받는 방법을 안내하는 것이 법적인 문제를 피하는 가장 확실한 방법입니다.

* 개인적인 사용을 위해 학교 등 공공장소의 기기로 웹툰을 다운로드하는 경우: **사적이용 아닐 확률 있음**

    *공중의 사용에 제공하기 위하여 설치된 복사기기, 스캐너, 사진기 등 문화체육관광부령으로 정하는 복제기기에 의한 복제*에 학교나 회사의 컴퓨터가 포함되는지는 확실하지 않지만, 혹시 모를 문제를 피하려면 집에서 개인적으로 사용하는 기기에서 패키지를 사용하세요.

## 공정 이용

> 저작권법 제35조의3(저작물의 공정한 이용)
>
> ① 제23조부터 제35조의2까지, 제101조의3부터 제101조의5까지의 경우 외에 저작물의 통상적인 이용 방법과 충돌하지 아니하고 저작자의 정당한 이익을 부당하게 해치지 아니하는 경우에는 저작물을 이용할 수 있다. <개정 2016. 3. 22.>
>
> ② 저작물 이용 행위가 제1항에 해당하는지를 판단할 때에는 다음 각 호의 사항등을 고려하여야 한다. <개정 2016. 3. 22.>
>
> 1. 이용의 목적 및 성격
> 2. 저작물의 종류 및 용도
> 3. 이용된 부분이 저작물 전체에서 차지하는 비중과 그 중요성
> 4. 저작물의 이용이 그 저작물의 현재 시장 또는 가치나 잠재적인 시장 또는 가치에 미치는 영향
>
> [본조신설 2011. 12. 2.]

다운로드받은 웹툰 전체 파일을 공유하는 행위가 공정 이용이 될 확률은 매우 낮습니다. 하지만 웹툰에 일부인 작은 스크린샷을 공유하거나 하는 등의 행위는 공정 이용이 될 수 있습니다.

## 한계

WebtoonScraper를 웹툰 플랫폼의 서버에 무리가 될 정도록 과다하게 사용하지 마세요. 이 경우 부도덕적일 뿐만 아니라 상황에 따라 DoS 공격으로 판단되어 계정 정지나 IP 밴 등이 이루어질 수 있습니다.

한국에는 저작권법 이외에도 많은 법이 있습니다. 저작권법에 만족하더라도 그 외의 법을 어길 가능성 역시 존재합니다.

또한 만약 자신이 한국 국민이 아니거나 다른 나라의 영토에 있다면 다른 국가 법의 대상이 될 수 있습니다(하지만 미국을 비롯한 대부분의 나라들은 [베른 협약](https://ko.wikipedia.org/wiki/%EB%B2%A0%EB%A5%B8_%ED%98%91%EC%95%BD)을 맺고 있어 법 조항은 대동소이합니다.).

다시 한 번 이야기하자면 WebtoonScraper를 사용하는 것을 합법이지만 사적이용을 넘어서서 자신이 다운로드받은 파일을 공유하는 것은 저작권법에 대한 적극적인 위반이며 죄질이 무거울 수 있습니다. 꼭 준법 의식을 가지고 사용해 주세요.
